// This file is auto-generated, don't edit it. Thanks.
package com.aliyun.sample;

import com.aliyun.tea.*;
import com.aliyun.ecs20140526.*;
import com.aliyun.ecs20140526.models.*;
import com.aliyun.teaopenapi.*;
import com.aliyun.teaopenapi.models.*;
import com.aliyun.teautil.*;
import com.aliyun.darabonba.array.*;
import com.aliyun.teaconsole.*;
import com.aliyun.darabonba.env.*;

public class Sample {

    /**
    * Initialization  初始化公共请求参数
    */
    public static com.aliyun.ecs20140526.Client Initialization(String regionId) throws Exception {
        Config config = new Config();
        // 您的AccessKey ID
        config.accessKeyId = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_ID");
        // 您的AccessKey Secret
        config.accessKeySecret = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_SECRET");
        // 您的可用区ID
        config.regionId = regionId;
        return new com.aliyun.ecs20140526.Client(config);
    }

    public static void main(String[] args_) throws Exception {
        java.util.List<String> args = java.util.Arrays.asList(args_);
        // 地域Id
        String regionId = args.get(0);
        // 网络类型: 
        // classic：经典网络  
        // vpc：专有网络VPC
        String networkType = args.get(1);
        // 实例规格
        //说明: 如果您指定了InstanceType，则无法指定Cores或者Memory。
        String instanceType = args.get(2);
        // 可用区域Id
        String zoneId = args.get(3);
        // 是否仅推荐ZoneId指定的可用区中的实例规格
        // 取值为Strict时，表示推荐实例规格限制在目标可用区下。
        // 取值为Include时，表示对目标可用区无要求时，优先在ZoneId指定可用区下推荐，若无合适结果，推荐范围扩大到地域下所有可用区。
        String zoneMatchMode = args.get(4);
        // 抢占式实例的竞价策略
        // NoSpot：正常按量付费实例。
        // SpotWithPriceLimit：设置上限价格的抢占式实例。
        // SpotAsPriceGo：系统自动出价，最高按量付费价格。
        // 说明 使用SpotStrategy时，InstanceChargerType必须设置为PostPaid。
        String spotStrategy = args.get(5);
        // ECS实例的计费方式
        // PrePaid：包年包月
        // PostPaid：按量付费
        String instanceChargeType = args.get(6);
        // 优先推荐策略
        // InventoryFirst：库存优先。
        // PriceFirst：价格优先，按每小时vCPU单价从低到高排序。
        // NewProductFirst：最新产品优先。
        String priorityStrategy = args.get(7);
        // 是否为I/O优化实例
        // optimized：I/O优化
        // none：非IO优化
        String ioOptimized = args.get(8);
        // 过滤不采纳的实例规格族集合
        java.util.List<String> instanceTypeFamily = java.util.Arrays.asList(
            args.get(9),
            args.get(10)
        );
        com.aliyun.ecs20140526.Client client = Sample.Initialization(regionId);
        // 通过备选实例规格创建ECS实例最佳实践
        String imageId = "centos_8_2_x64_20G_alibase_20201120.vhd";
        String vSwitchId = "";
        String securityGroupId = "sg-bp1xxxxxxxx";
        Sample.DescribeRecommendInstanceType(client, regionId, networkType, zoneId, zoneMatchMode, instanceType, spotStrategy, instanceChargeType, instanceTypeFamily, priorityStrategy, ioOptimized, imageId, vSwitchId, securityGroupId);
    }

    /**
    * DescribeRecommendInstanceType    通过备选实例规格创建ECS实例最佳实践
    * 该场景中，在调用RunInstances创建ECS实例时判断是否发生库存不足等错误，如果发生错误，将调用DescribeRecommendInstanceType查询备选实例，然后通过备选实例规格重新创建ECS实例。
    */
    public static void DescribeRecommendInstanceType(com.aliyun.ecs20140526.Client client, String regionId, String networkType, String zoneId, String zoneMatchMode, String instanceType, String spotStrategy, String instanceChargeType, java.util.List<String> instanceTypeFamily, String priorityStrategy, String ioOptimized, String imageId, String vSwitchId, String securityGroupId) throws Exception {
        RunInstancesRequest request1 = new RunInstancesRequest()
                .setRegionId(regionId)
                .setInstanceType(instanceType)
                .setImageId(imageId)
                .setSecurityGroupId(securityGroupId)
                .setInstanceName("MyFirstEcsInstance")
                .setDescription("MyFirstEcsInstance")
                .setZoneId(zoneId)
                .setVSwitchId(vSwitchId)
                .setAmount(1)
                .setDryRun(false);
        try {
            com.aliyun.teaconsole.Client.log("--------------------通过备选实例规格创建ECS实例最佳实践--------------------");
            com.aliyun.teaconsole.Client.log("--------------------创建实例开始--------------------");
            RunInstancesResponse responces = client.runInstances(request1);
            com.aliyun.teaconsole.Client.log("--------------------创建实例成功，实例ID:" + com.aliyun.teautil.Common.toJSONString(responces.body.instanceIdSets.instanceIdSet) + "--------------------");
        } catch (TeaException error) {
            String errorCode = error.code;
            com.aliyun.teaconsole.Client.log("--------------------创建实例失败，error:" + com.aliyun.teautil.Common.toJSONString(errorCode) + "--------------------");
            // 原实例规格创建ECS实例失败，需要寻找替代实例规格的错误码。
            java.util.List<String> noStockCode = java.util.Arrays.asList(
                "OperationDenied.NoStock",
                "Zone.NotOnSale",
                "InvalidResourceType.NotSupported",
                "InstanceType.Offline"
            );
            // 如果匹配错误码，将查询推荐的备选实例规格信息。
            if (com.aliyun.darabonba.array.Client.contains(noStockCode, errorCode)) {
                DescribeRecommendInstanceTypeRequest request = new DescribeRecommendInstanceTypeRequest();
                request.regionId = regionId;
                request.networkType = networkType;
                // 默认按照资源的库存充足的程度排序。
                request.priorityStrategy = priorityStrategy;
                // 实例相关的参数信息与创建ECS实例时保持一致。
                request.ioOptimized = ioOptimized;
                request.instanceChargeType = instanceChargeType;
                request.spotStrategy = spotStrategy;
                request.instanceType = instanceType;
                // 限制推荐的实例规格族的范围。
                request.instanceTypeFamily = instanceTypeFamily;
                // 根据VSwitch所在可用区选择ZoneId。
                if (!com.aliyun.teautil.Common.empty(vSwitchId)) {
                    DescribeVSwitchesRequest describeVSwitchesRequest = new DescribeVSwitchesRequest()
                            .setVSwitchId(vSwitchId)
                            .setRegionId(regionId);
                    DescribeVSwitchesResponse describeVSwitchesResponse = client.describeVSwitches(describeVSwitchesRequest);
                    java.util.List<DescribeVSwitchesResponseBody.DescribeVSwitchesResponseBodyVSwitchesVSwitch> vSwitches = describeVSwitchesResponse.body.vSwitches.vSwitch;
                    DescribeVSwitchesResponseBody.DescribeVSwitchesResponseBodyVSwitchesVSwitch vSwitch = vSwitches.get(0);
                    zoneId = vSwitch.zoneId;
                }

                // 如果需要限制在原可用区下推荐备选的实例规格，则需要设置可用区的匹配模式为Strict。
                if (!com.aliyun.teautil.Common.empty(zoneId)) {
                    request.zoneMatchMode = zoneMatchMode;
                }

                DescribeRecommendInstanceTypeResponse response = client.describeRecommendInstanceType(request);
                com.aliyun.teaconsole.Client.log("--------------------备选方案:--------------------");
                java.util.List<DescribeRecommendInstanceTypeResponseBody.DescribeRecommendInstanceTypeResponseBodyDataRecommendInstanceType> recommendInstanceTypes = response.body.data.recommendInstanceType;
                // 查询原实例规格的详细信息。
                DescribeInstanceTypesRequest typeRequest = new DescribeInstanceTypesRequest()
                        .setInstanceTypes(java.util.Arrays.asList(
                            instanceType
                        ));
                DescribeInstanceTypesResponse typeResponse = client.describeInstanceTypes(typeRequest);
                DescribeInstanceTypesResponseBody.DescribeInstanceTypesResponseBodyInstanceTypesInstanceType originType = typeResponse.body.instanceTypes.instanceType.get(0);
                for (DescribeRecommendInstanceTypeResponseBody.DescribeRecommendInstanceTypeResponseBodyDataRecommendInstanceType recommendInstanceType : recommendInstanceTypes) {
                    if (!com.aliyun.teautil.Common.equalString(recommendInstanceType.instanceType.instanceType, instanceType)) {
                        // 您可以增加一些实例规格过滤条件，比如要求备选的目标实例规格与原实例规格有相同的核数和内存大小。
                        if (com.aliyun.teautil.Common.equalNumber(originType.cpuCoreCount, recommendInstanceType.instanceType.cores)) {
                            com.aliyun.teaconsole.Client.log("实例规格: " + com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(recommendInstanceType.instanceType)) + "");
                            com.aliyun.teaconsole.Client.log("可用区: " + com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(recommendInstanceType.zones)) + "");
                            com.aliyun.teaconsole.Client.log("地域: " + com.aliyun.teautil.Common.toJSONString(recommendInstanceType.regionId) + "");
                            com.aliyun.teaconsole.Client.log("计费方式: " + com.aliyun.teautil.Common.toJSONString(recommendInstanceType.instanceChargeType) + "");
                            com.aliyun.teaconsole.Client.log("竞价策略信息: " + com.aliyun.teautil.Common.toJSONString(recommendInstanceType.spotStrategy) + "");
                            com.aliyun.teaconsole.Client.log("---------------------------------------------------");
                            com.aliyun.teaconsole.Client.log("--------------------使用备选方案创建实例的JSON返回结果：--------------------");
                            request1.instanceType = recommendInstanceType.instanceType.instanceType;
                            RunInstancesResponse responces1 = client.runInstances(request1);
                            com.aliyun.teaconsole.Client.log("--------------------创建实例成功，实例ID:" + com.aliyun.teautil.Common.toJSONString(responces1.body.instanceIdSets.instanceIdSet) + "--------------------");
                            break;
                        }

                    }

                }
            }

        } catch (Exception _error) {
            TeaException error = new TeaException(_error.getMessage(), _error);
            String errorCode = error.code;
            com.aliyun.teaconsole.Client.log("--------------------创建实例失败，error:" + com.aliyun.teautil.Common.toJSONString(errorCode) + "--------------------");
            // 原实例规格创建ECS实例失败，需要寻找替代实例规格的错误码。
            java.util.List<String> noStockCode = java.util.Arrays.asList(
                "OperationDenied.NoStock",
                "Zone.NotOnSale",
                "InvalidResourceType.NotSupported",
                "InstanceType.Offline"
            );
            // 如果匹配错误码，将查询推荐的备选实例规格信息。
            if (com.aliyun.darabonba.array.Client.contains(noStockCode, errorCode)) {
                DescribeRecommendInstanceTypeRequest request = new DescribeRecommendInstanceTypeRequest();
                request.regionId = regionId;
                request.networkType = networkType;
                // 默认按照资源的库存充足的程度排序。
                request.priorityStrategy = priorityStrategy;
                // 实例相关的参数信息与创建ECS实例时保持一致。
                request.ioOptimized = ioOptimized;
                request.instanceChargeType = instanceChargeType;
                request.spotStrategy = spotStrategy;
                request.instanceType = instanceType;
                // 限制推荐的实例规格族的范围。
                request.instanceTypeFamily = instanceTypeFamily;
                // 根据VSwitch所在可用区选择ZoneId。
                if (!com.aliyun.teautil.Common.empty(vSwitchId)) {
                    DescribeVSwitchesRequest describeVSwitchesRequest = new DescribeVSwitchesRequest()
                            .setVSwitchId(vSwitchId)
                            .setRegionId(regionId);
                    DescribeVSwitchesResponse describeVSwitchesResponse = client.describeVSwitches(describeVSwitchesRequest);
                    java.util.List<DescribeVSwitchesResponseBody.DescribeVSwitchesResponseBodyVSwitchesVSwitch> vSwitches = describeVSwitchesResponse.body.vSwitches.vSwitch;
                    DescribeVSwitchesResponseBody.DescribeVSwitchesResponseBodyVSwitchesVSwitch vSwitch = vSwitches.get(0);
                    zoneId = vSwitch.zoneId;
                }

                // 如果需要限制在原可用区下推荐备选的实例规格，则需要设置可用区的匹配模式为Strict。
                if (!com.aliyun.teautil.Common.empty(zoneId)) {
                    request.zoneMatchMode = zoneMatchMode;
                }

                DescribeRecommendInstanceTypeResponse response = client.describeRecommendInstanceType(request);
                com.aliyun.teaconsole.Client.log("--------------------备选方案:--------------------");
                java.util.List<DescribeRecommendInstanceTypeResponseBody.DescribeRecommendInstanceTypeResponseBodyDataRecommendInstanceType> recommendInstanceTypes = response.body.data.recommendInstanceType;
                // 查询原实例规格的详细信息。
                DescribeInstanceTypesRequest typeRequest = new DescribeInstanceTypesRequest()
                        .setInstanceTypes(java.util.Arrays.asList(
                            instanceType
                        ));
                DescribeInstanceTypesResponse typeResponse = client.describeInstanceTypes(typeRequest);
                DescribeInstanceTypesResponseBody.DescribeInstanceTypesResponseBodyInstanceTypesInstanceType originType = typeResponse.body.instanceTypes.instanceType.get(0);
                for (DescribeRecommendInstanceTypeResponseBody.DescribeRecommendInstanceTypeResponseBodyDataRecommendInstanceType recommendInstanceType : recommendInstanceTypes) {
                    if (!com.aliyun.teautil.Common.equalString(recommendInstanceType.instanceType.instanceType, instanceType)) {
                        // 您可以增加一些实例规格过滤条件，比如要求备选的目标实例规格与原实例规格有相同的核数和内存大小。
                        if (com.aliyun.teautil.Common.equalNumber(originType.cpuCoreCount, recommendInstanceType.instanceType.cores)) {
                            com.aliyun.teaconsole.Client.log("实例规格: " + com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(recommendInstanceType.instanceType)) + "");
                            com.aliyun.teaconsole.Client.log("可用区: " + com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(recommendInstanceType.zones)) + "");
                            com.aliyun.teaconsole.Client.log("地域: " + com.aliyun.teautil.Common.toJSONString(recommendInstanceType.regionId) + "");
                            com.aliyun.teaconsole.Client.log("计费方式: " + com.aliyun.teautil.Common.toJSONString(recommendInstanceType.instanceChargeType) + "");
                            com.aliyun.teaconsole.Client.log("竞价策略信息: " + com.aliyun.teautil.Common.toJSONString(recommendInstanceType.spotStrategy) + "");
                            com.aliyun.teaconsole.Client.log("---------------------------------------------------");
                            com.aliyun.teaconsole.Client.log("--------------------使用备选方案创建实例的JSON返回结果：--------------------");
                            request1.instanceType = recommendInstanceType.instanceType.instanceType;
                            RunInstancesResponse responces1 = client.runInstances(request1);
                            com.aliyun.teaconsole.Client.log("--------------------创建实例成功，实例ID:" + com.aliyun.teautil.Common.toJSONString(responces1.body.instanceIdSets.instanceIdSet) + "--------------------");
                            break;
                        }

                    }

                }
            }

        }        
    }
}
